<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Eddie: /builds/eclipse/oniro-core/eddie/linux/communication/include/common.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Eddie
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_88e6415a3128b404f1102a130772bdb6.html">linux</a></li><li class="navelem"><a class="el" href="dir_9d6112f7740eb6b19e6896a373a5986f.html">communication</a></li><li class="navelem"><a class="el" href="dir_046dfdec3fa9891163197d92ca19a5c8.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">common.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * SPDX-License-Identifier: Apache-2.0</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * SPDX-FileCopyrightText: Huawei Inc.</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * SPDX-FileCopyrightText: Politecnico Di Milano</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef COMMON_H</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define COMMON_H</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;eddie.h&quot;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;unordered_map&gt;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;unordered_set&gt;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;list&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;coap3/coap.h&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;cstdio&gt;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;regex&gt;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#define LOG_DBG(_str, ...) printf(_str &quot;\n&quot;</span>, ##__VA_ARGS__)</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#define LOG_INFO(_str, ...) printf(_str &quot;\n&quot;</span>, ##__VA_ARGS__)</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#define LOG_ERR(_str, ...) printf(_str &quot;\n&quot;</span>, ##__VA_ARGS__)</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keywordtype">int</span> resolve_address(<span class="keyword">const</span> <span class="keywordtype">char</span> *host, <span class="keyword">const</span> <span class="keywordtype">char</span> *service, coap_address_t *dst);</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;std::string get_local_node_ip();</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;method_t coap_method_to_method(coap_pdu_code_t method);</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;coap_pdu_code_t method_to_coap_method(method_t method);</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keywordtype">bool</span> match(<span class="keyword">const</span> std::string &amp;src, <span class="keyword">const</span> std::string &amp;dst, <span class="keywordtype">int</span> is_prefix);</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;std::string ip_to_url(<span class="keyword">const</span> std::string&amp; ip, <span class="keyword">const</span> std::string&amp; port);</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160; </div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;std::vector&lt;std::string&gt; split(<span class="keyword">const</span> std::string &amp;s, <span class="keywordtype">char</span> delimiter);</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;std::string url_encode(<span class="keyword">const</span> std::string &amp;value);</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160; </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> Key, <span class="keyword">class</span> Value&gt;</div>
<div class="line"><a name="l00091"></a><span class="lineno"><a class="line" href="classThreadSafeMap.html">   91</a></span>&#160;<span class="keyword">class </span><a class="code" href="classThreadSafeMap.html">ThreadSafeMap</a> {</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    std::unordered_map&lt;Key, Value&gt; c_;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    std::mutex m_;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    Value get(Key <span class="keyword">const</span> &amp;k) {</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        std::unique_lock&lt;decltype(m_)&gt; lock(m_);</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        Value elem = c_[k];</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        <span class="keywordflow">return</span> elem;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    }</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160; </div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keywordtype">bool</span> exists(Key <span class="keyword">const</span> &amp;k) {</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        std::unique_lock&lt;decltype(m_)&gt; lock(m_);</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        <span class="keywordflow">return</span> c_.find(k) != c_.end();</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    }</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160; </div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    std::list&lt;Value&gt; get_all() {</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        std::unique_lock&lt;decltype(m_)&gt; lock(m_);</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        std::list&lt;Value&gt; return_list;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160; </div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        <span class="keywordflow">for</span>(<span class="keyword">auto</span> <span class="keyword">const</span>&amp; imap: c_)</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;            return_list.push_back(imap.second);</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160; </div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        <span class="keywordflow">return</span> return_list;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    }</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160; </div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">class</span> Value2&gt;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="keywordtype">void</span> set(Key <span class="keyword">const</span> &amp;k, Value2 &amp;&amp;v) {</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        std::unique_lock&lt;decltype(m_)&gt; lock(m_);</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        c_[k] = std::forward&lt;Value2&gt;(v);</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    }</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160; </div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keywordtype">void</span> erase(Key <span class="keyword">const</span> &amp;k) {</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        std::unique_lock&lt;decltype(m_)&gt; lock(m_);</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        c_.erase(k);</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    }</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160; </div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keywordtype">void</span> delete_all() {</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        std::unique_lock&lt;decltype(m_)&gt; lock(m_);</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        c_.erase(c_.begin(), c_.end());</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    }</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160; </div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    <span class="keywordtype">int</span> empty() {</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        std::unique_lock&lt;decltype(m_)&gt; lock(m_);</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        <span class="keywordflow">return</span> c_.empty();</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    }</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;};</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160; </div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> Key, <span class="keyword">class</span> Value&gt;</div>
<div class="line"><a name="l00141"></a><span class="lineno"><a class="line" href="classThreadSafeStorage.html">  141</a></span>&#160;<span class="keyword">class </span><a class="code" href="classThreadSafeStorage.html">ThreadSafeStorage</a> {</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    std::unordered_multimap&lt;Key, Value&gt; mm_;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    std::unordered_set&lt;Key&gt; s_;</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160; </div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    std::mutex m_;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160; </div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    std::list&lt;Key&gt; get_valid_keys() {</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        std::unique_lock&lt;decltype(m_)&gt; lock(m_);</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160; </div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        std::list&lt;Key&gt; return_container;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        <span class="keywordflow">for</span> (<span class="keyword">auto</span> key: s_) return_container.push_back(key);</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160; </div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <span class="keywordflow">return</span> return_container;</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    }</div>
<div class="line"><a name="l00160"></a><span class="lineno"><a class="line" href="classThreadSafeStorage.html#ae9e0c17043a5d327ca5a10ffb624ca42">  160</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classThreadSafeStorage.html#ae9e0c17043a5d327ca5a10ffb624ca42">insert_valid_key</a>(Key <span class="keyword">const</span> &amp;k) {</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        std::unique_lock&lt;decltype(m_)&gt; lock(m_);</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        s_.insert(k);</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    }</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160; </div>
<div class="line"><a name="l00171"></a><span class="lineno"><a class="line" href="classThreadSafeStorage.html#a2f4857ce15275f638f525db39d5e6672">  171</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classThreadSafeStorage.html#a2f4857ce15275f638f525db39d5e6672">remove_valid_key</a> (Key <span class="keyword">const</span> &amp;k) {</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        std::unique_lock&lt;decltype(m_)&gt; lock(m_);</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        s_.erase(k);</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        mm_.erase(k);</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    }</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160; </div>
<div class="line"><a name="l00182"></a><span class="lineno"><a class="line" href="classThreadSafeStorage.html#af991b7ee741ae33a5e9b95b67272d40b">  182</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classThreadSafeStorage.html#af991b7ee741ae33a5e9b95b67272d40b">contains_key</a>(Key <span class="keyword">const</span> &amp;k) {</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        std::unique_lock&lt;decltype(m_)&gt; lock(m_);</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        <span class="keyword">auto</span> result = s_.find(k);</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        <span class="keywordflow">return</span> result != s_.end();</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    }</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160; </div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">class</span> Value2&gt;</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    <span class="keywordtype">void</span> insert_new_message(Key <span class="keyword">const</span> &amp;k, Value2 &amp;&amp;v) {</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        std::unique_lock&lt;decltype(m_)&gt; lock(m_);</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160; </div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        <span class="keywordflow">if</span> (s_.find(k) != s_.end()) {</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;            mm_.insert(std::make_pair(k, v));</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        }</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    }</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160; </div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    std::list&lt;Value&gt; get(Key <span class="keyword">const</span> &amp;k) {</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        std::unique_lock&lt;decltype(m_)&gt; lock(m_);</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        std::list&lt;Value&gt; return_list;</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160; </div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        <span class="keywordflow">if</span> (s_.find(k) != s_.end()) {</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;            <span class="keyword">auto</span> items = mm_.equal_range(k);</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160; </div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;            <span class="keywordflow">for</span> (<span class="keyword">auto</span> item = items.first; item != items.second; ++item) {</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;                return_list.push_back(item-&gt;second);</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;            }</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        }</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160; </div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        <span class="keywordflow">return</span> return_list;</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    }</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160; </div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    <span class="keywordtype">void</span> delete_all() {</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        std::unique_lock&lt;decltype(m_)&gt; lock(m_);</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;        s_.erase(s_.begin(), s_.end());</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;        mm_.erase(mm_.begin(), mm_.end());</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    }</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160; </div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    <span class="keywordtype">int</span> empty() {</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        std::unique_lock&lt;decltype(m_)&gt; lock(m_);</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        <span class="keywordflow">return</span> mm_.empty();</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    }</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;};</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160; </div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="aclassThreadSafeMap_html"><div class="ttname"><a href="classThreadSafeMap.html">ThreadSafeMap</a></div><div class="ttdef"><b>Definition:</b> common.h:91</div></div>
<div class="ttc" id="aclassThreadSafeStorage_html"><div class="ttname"><a href="classThreadSafeStorage.html">ThreadSafeStorage</a></div><div class="ttdef"><b>Definition:</b> common.h:141</div></div>
<div class="ttc" id="aclassThreadSafeStorage_html_a2f4857ce15275f638f525db39d5e6672"><div class="ttname"><a href="classThreadSafeStorage.html#a2f4857ce15275f638f525db39d5e6672">ThreadSafeStorage::remove_valid_key</a></div><div class="ttdeci">void remove_valid_key(Key const &amp;k)</div><div class="ttdef"><b>Definition:</b> common.h:171</div></div>
<div class="ttc" id="aclassThreadSafeStorage_html_ae9e0c17043a5d327ca5a10ffb624ca42"><div class="ttname"><a href="classThreadSafeStorage.html#ae9e0c17043a5d327ca5a10ffb624ca42">ThreadSafeStorage::insert_valid_key</a></div><div class="ttdeci">void insert_valid_key(Key const &amp;k)</div><div class="ttdef"><b>Definition:</b> common.h:160</div></div>
<div class="ttc" id="aclassThreadSafeStorage_html_af991b7ee741ae33a5e9b95b67272d40b"><div class="ttname"><a href="classThreadSafeStorage.html#af991b7ee741ae33a5e9b95b67272d40b">ThreadSafeStorage::contains_key</a></div><div class="ttdeci">int contains_key(Key const &amp;k)</div><div class="ttdef"><b>Definition:</b> common.h:182</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
